PANICButton = { } ;
function PANICButton:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function PANICButton:create()
	local b = CreateFrame("Button", "PanicButton", UIParent, "ActionButtonTemplate,SecureActionButtonTemplate")
	b:SetPoint("TOPLEFT", 200, -200) --off the screen
	b:SetSize(self.config.iconSize, self.config.iconSize)
	b:EnableMouse(true)
	b.texture = b:CreateTexture()
	b.texture:SetTexture(self.config.icon)
	b.texture:SetAllPoints(b)
	b.background = b.texture
	b:Show()
	b:SetAttribute("type", "macro")
	self.panicFrame = b
	self.isHidden = true
end

function PANICButton:moveOut()
	--print("moving " .. self.i)
	self.panicFrame:SetPoint("TOPLEFT", -200, 200)
end

function PANICButton:prepare(spell, icon)
	self.spell = spell
	self.icon = icon
	--self:test()

	self.panicFrame.texture:SetTexture(self.icon)
	self.panicFrame.texture:SetAllPoints(self.panicFrame)

	if (self.spell == 'Healthstone') then
		self.panicFrame:SetAttribute("macrotext","/use " .. self.spell)
		--print("/use " .. self.spell)
	else
		local name, rank, icon, castingTime, minRange, maxRange, spellID = GetSpellInfo(self.spell)
		if (name) then
			self.panicFrame:SetAttribute("macrotext","/cast [@player] " .. self.spell)
			--print("/cast [@player] " .. self.spell)
		end
	end

end

function PANICButton:clear()
	self.spell = nil
end


function PANICButton:getSpell()
	return self.spell
end

function PANICButton:test()
	print("MACRO IS " .. self.spell)
end

function PANICButton:show()
	if (self.isHidden) then
		--print("Showing " .. self.spell)
		self.panicFrame:SetPoint("TOPLEFT",math.floor(GetScreenWidth()/2-self.config.iconSize/2),-math.floor(GetScreenHeight()/15))
		self.panicFrame.texture:SetAlpha(1)
		self.panicFrame:SetAlpha(1)
		self.isHidden = false
	end
end

function PANICButton:hide()
	if (not self.isHidden) then
		self:moveOut()
		--print("Hiding ".. self.macro)
		self.panicFrame.texture:SetAlpha(0.25)
		self.panicFrame:SetAlpha(0.2)
		self.isHidden = true
	end
end

function PANICButton:dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. self:dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end
